<template>
  <v-app>
    <v-card dark :loading="loading">
      <v-card-title class="text-center justify-center pt-3 pb-0">
        <span class="body-2 text-uppercase font-weight-normal">{{ name }}</span>
      </v-card-title>
      <v-tabs
          centered elevation-0
          icons-and-text
          v-model="choice"
          :color="color"
          hide-slider
          dark>
        <v-tabs-slider color="white"></v-tabs-slider>
        <v-tab
            v-for="item in items"
            :key="item.id">
          {{ item.name }}
          <v-icon v-if="typeof item.icon !== 'undefined'">{{ item.icon }}</v-icon>
          <img v-else-if="typeof item.image !== 'undefined'" :src="item.image" style="height:24px;width:auto;">
        </v-tab>
      </v-tabs>
    </v-card>
    <v-content>
      <embed
          v-for="item in embed"
          :key="item.id"
          :src="item.link"
          @load="loaded(item.id)"
          :height="item.visible ? '100%' : '0'"
          :width="item.visible ? '100%' : '0'">
    </v-content>
    <v-footer dark padless>
      <v-col class="text-center" cols="12" style="color:hsla(0,0%,100%,.6);">
        <span class="body-2">Copyright &copy; {{ new Date().getFullYear() }} <strong>{{ holder }}</strong> All rights reserved.</span>
      </v-col>
  </v-footer>
  </v-app>
</template>

<script>
export default {
  name: 'App',
  data() {
    let sites = JSON.parse(this.read())
    document.title = sites.title

    // Make sure that every object in "sites" has key field "id".
    // And make sure that "visible" and "external" keys are mutually exclusive.
    // The decision rules are:
    // external = undefined or external = false:
    //   delete external (if any)
    //   visible = defined: honor given visible value
    //   visible = undefined: visible = false
    // external = true:
    //   delete visible
    for (let i = 0; i < sites.items.length; i++) {
      sites.items[i].id = i
      if (!('external' in sites.items[i])) {
        if (!('visible' in sites.items[i])) {
          sites.items[i].visible = false
        }
      } else {
        if (!sites.items[i].external) {
          delete sites.items[i].external
          if (!('visible' in sites.items[i])) {
            sites.items[i].visible = false
          }
        } else {
          delete sites.items[i].visible
        }
      }
    }

    // Find out default visible page
    let choice = -1
    let first = -1
    for (let i = 0; i < sites.items.length; i++) {
      if (first === -1 && 'visible' in sites.items[i]) {
        first = i
      }
      if ('visible' in sites.items[i] && sites.items[i].visible) {
        choice = i
        break
      }
    }
    if (choice === -1 && first !== -1) {
      choice = first
      sites.items[choice].visible = true
    } else {
      // So what do you want. You will see the loading bar forever
    }

    return {
      color: "yellow darken-2",
      choice: choice,
      loading: "",
      ...sites,
    }
  },
  created() {
    this.loading = this.color
  },
  watch: {
    choice() {
      for (let i = 0; i < this.items.length; i++) {
        if ('visible' in this.items[i]) {
          this.items[i].visible = this.items[i].id === this.choice
        }
      }
      if ('external' in this.items[this.choice]) {
        window.open(this.items[this.choice].link)
      }
    }
  },
  computed: {
    embed() {
      const filtered = []
      this.items.forEach(function(item) {
        if (!('external' in item)) {
          filtered.push(item)
        }
      })
      return filtered
    },
  },
  methods: {
    read() {
      let request = new XMLHttpRequest()
      request.overrideMimeType("application/json")
      request.open('GET', process.env.BASE_URL + 'sites.json', false)
      request.send()
      return request.status === 200 ? request.responseText : '{}'
    },
    loaded(id) {
      if (this.choice === id) {
       this.loading = false
      }
    },
  },
};
</script>
